# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class AnalyticsSurvey(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AnalyticsSurvey - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'survey_id': 'str',
            'survey_form_id': 'str',
            'survey_form_context_id': 'str',
            'user_id': 'str',
            'queue_id': 'str',
            'status': 'str',
            'geto_survey_total_score': 'int',
            'survey_promoter_score': 'int',
            'survey_completed_time': 'int',
            'media_types': 'list[str]',
            'language_ids': 'list[str]',
            'skill_ids': 'list[str]'
        }

        self.attribute_map = {
            'survey_id': 'surveyId',
            'survey_form_id': 'surveyFormId',
            'survey_form_context_id': 'surveyFormContextId',
            'user_id': 'userId',
            'queue_id': 'queueId',
            'status': 'status',
            'geto_survey_total_score': 'getoSurveyTotalScore',
            'survey_promoter_score': 'surveyPromoterScore',
            'survey_completed_time': 'surveyCompletedTime',
            'media_types': 'mediaTypes',
            'language_ids': 'languageIds',
            'skill_ids': 'skillIds'
        }

        self._survey_id = None
        self._survey_form_id = None
        self._survey_form_context_id = None
        self._user_id = None
        self._queue_id = None
        self._status = None
        self._geto_survey_total_score = None
        self._survey_promoter_score = None
        self._survey_completed_time = None
        self._media_types = None
        self._language_ids = None
        self._skill_ids = None

    @property
    def survey_id(self):
        """
        Gets the survey_id of this AnalyticsSurvey.
        Unique identifier for the survey

        :return: The survey_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._survey_id

    @survey_id.setter
    def survey_id(self, survey_id):
        """
        Sets the survey_id of this AnalyticsSurvey.
        Unique identifier for the survey

        :param survey_id: The survey_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._survey_id = survey_id

    @property
    def survey_form_id(self):
        """
        Gets the survey_form_id of this AnalyticsSurvey.
        Unique identifier for the survey form

        :return: The survey_form_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._survey_form_id

    @survey_form_id.setter
    def survey_form_id(self, survey_form_id):
        """
        Sets the survey_form_id of this AnalyticsSurvey.
        Unique identifier for the survey form

        :param survey_form_id: The survey_form_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._survey_form_id = survey_form_id

    @property
    def survey_form_context_id(self):
        """
        Gets the survey_form_context_id of this AnalyticsSurvey.
        Unique identifier for the survey form, regardless of version

        :return: The survey_form_context_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._survey_form_context_id

    @survey_form_context_id.setter
    def survey_form_context_id(self, survey_form_context_id):
        """
        Sets the survey_form_context_id of this AnalyticsSurvey.
        Unique identifier for the survey form, regardless of version

        :param survey_form_context_id: The survey_form_context_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._survey_form_context_id = survey_form_context_id

    @property
    def user_id(self):
        """
        Gets the user_id of this AnalyticsSurvey.
        A unique identifier of the PureCloud user

        :return: The user_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """
        Sets the user_id of this AnalyticsSurvey.
        A unique identifier of the PureCloud user

        :param user_id: The user_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._user_id = user_id

    @property
    def queue_id(self):
        """
        Gets the queue_id of this AnalyticsSurvey.
        Unique identifier for the queue the conversation was on

        :return: The queue_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._queue_id

    @queue_id.setter
    def queue_id(self, queue_id):
        """
        Sets the queue_id of this AnalyticsSurvey.
        Unique identifier for the queue the conversation was on

        :param queue_id: The queue_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._queue_id = queue_id

    @property
    def status(self):
        """
        Gets the status of this AnalyticsSurvey.
        Survey status

        :return: The status of this AnalyticsSurvey.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this AnalyticsSurvey.
        Survey status

        :param status: The status of this AnalyticsSurvey.
        :type: str
        """
        
        self._status = status

    @property
    def geto_survey_total_score(self):
        """
        Gets the geto_survey_total_score of this AnalyticsSurvey.
        Creation date of survey

        :return: The geto_survey_total_score of this AnalyticsSurvey.
        :rtype: int
        """
        return self._geto_survey_total_score

    @geto_survey_total_score.setter
    def geto_survey_total_score(self, geto_survey_total_score):
        """
        Sets the geto_survey_total_score of this AnalyticsSurvey.
        Creation date of survey

        :param geto_survey_total_score: The geto_survey_total_score of this AnalyticsSurvey.
        :type: int
        """
        
        self._geto_survey_total_score = geto_survey_total_score

    @property
    def survey_promoter_score(self):
        """
        Gets the survey_promoter_score of this AnalyticsSurvey.
        NPS score of the survey

        :return: The survey_promoter_score of this AnalyticsSurvey.
        :rtype: int
        """
        return self._survey_promoter_score

    @survey_promoter_score.setter
    def survey_promoter_score(self, survey_promoter_score):
        """
        Sets the survey_promoter_score of this AnalyticsSurvey.
        NPS score of the survey

        :param survey_promoter_score: The survey_promoter_score of this AnalyticsSurvey.
        :type: int
        """
        
        self._survey_promoter_score = survey_promoter_score

    @property
    def survey_completed_time(self):
        """
        Gets the survey_completed_time of this AnalyticsSurvey.
        Completion time of the survey, in ms since the epoch, 1970-01-01T00:00:00.000Z

        :return: The survey_completed_time of this AnalyticsSurvey.
        :rtype: int
        """
        return self._survey_completed_time

    @survey_completed_time.setter
    def survey_completed_time(self, survey_completed_time):
        """
        Sets the survey_completed_time of this AnalyticsSurvey.
        Completion time of the survey, in ms since the epoch, 1970-01-01T00:00:00.000Z

        :param survey_completed_time: The survey_completed_time of this AnalyticsSurvey.
        :type: int
        """
        
        self._survey_completed_time = survey_completed_time

    @property
    def media_types(self):
        """
        Gets the media_types of this AnalyticsSurvey.
        Media types associated with the conversation

        :return: The media_types of this AnalyticsSurvey.
        :rtype: list[str]
        """
        return self._media_types

    @media_types.setter
    def media_types(self, media_types):
        """
        Sets the media_types of this AnalyticsSurvey.
        Media types associated with the conversation

        :param media_types: The media_types of this AnalyticsSurvey.
        :type: list[str]
        """
        
        self._media_types = media_types

    @property
    def language_ids(self):
        """
        Gets the language_ids of this AnalyticsSurvey.
        Language IDs associated with the conversation

        :return: The language_ids of this AnalyticsSurvey.
        :rtype: list[str]
        """
        return self._language_ids

    @language_ids.setter
    def language_ids(self, language_ids):
        """
        Sets the language_ids of this AnalyticsSurvey.
        Language IDs associated with the conversation

        :param language_ids: The language_ids of this AnalyticsSurvey.
        :type: list[str]
        """
        
        self._language_ids = language_ids

    @property
    def skill_ids(self):
        """
        Gets the skill_ids of this AnalyticsSurvey.
        Skill IDs associated with the conversation

        :return: The skill_ids of this AnalyticsSurvey.
        :rtype: list[str]
        """
        return self._skill_ids

    @skill_ids.setter
    def skill_ids(self, skill_ids):
        """
        Sets the skill_ids of this AnalyticsSurvey.
        Skill IDs associated with the conversation

        :param skill_ids: The skill_ids of this AnalyticsSurvey.
        :type: list[str]
        """
        
        self._skill_ids = skill_ids

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

